; JRiver Media Center Advanced External Program Launcher Verrsion: 150911; Author: jmone
; Thread on Interact: http://yabb.jriver.com/interact/index.php?topic=98984.0

; --------------------------------------------------------------------------------------------------------
; AutoHotKey Environment Settings - No need to change
; --------------------------------------------------------------------------------------------------------
#NoEnv
;#NoTrayIcon 
#Persistent 
#SingleInstance, Force
SendMode Input
SetWorkingDir %A_ScriptDir%
SetTitleMatchMode, 2
SetTitleMatchMode, Slow

; --------------------------------------------------------------------------------------------------------
; Record existing Display Settings - No need to change
; --------------------------------------------------------------------------------------------------------
VarSetCapacity(device_mode,126)
success := DllCall("EnumDisplaySettings","uint",0,"uint",-1,"uint",&device_mode) 
sW:=NumGet(&device_mode,108,"uint4")  ;width 
sH:=NumGet(&device_mode,112,"uint4")  ;height 
cD:=NumGet(&device_mode,104,"uint4")  ;bit depth
rR:=NumGet(&device_mode,120,"uint4")  ;frequency 

; --------------------------------------------------------------------------------------------------------
; Read and Check Variables sent from MC - No need to change
; --------------------------------------------------------------------------------------------------------
Loop, %0%  ; For each parameter:
{
    Par%A_Index% := %A_Index%
}
StringSplit, Var,Par1, `,

If !Var1 ; check there is a filename specified
{
  msgbox There is Nothing to play - Process will Close
  ExitApp
}
If !Var2 ; check there is an external player specified
{
  msgbox There was no External Player specified - Process will Close
  ExitApp
}

StringReplace,Var1,Var1,\BDMV\index.bluray;1,  ;shortens MC's Bluray "Filename" to just the Path

; the following checks to see if it is file or on a Disk Drive and then finds the drive letter to use
If Var1 not contains \\,:
{
  StringReplace, Var1, Var1, %A_SPACE%, _, All
  StringGetPos, pos, Var1, \
  StringLeft, Var1, Var1, pos
  DriveGet, l_Temp, List
  Loop, Parse, l_Temp
  {
    DriveGet, Label, Label, %A_LoopField%:
    If Label contains %Var1%
    {
      Var1 = %A_LoopField%:\
      Break
    }
  }
}

; ********************************************************************************************************
; User Settings - Edit the values to match your player below
; ********************************************************************************************************
-------------- Media Center Configuration ----------------------------------------------------------------
If ProcessExist("Media Center 20.exe")
{
  MC_Path:="C:\Program Files (x86)\J River\Media Center 20\Media Center 20.exe" ; Enter Full path to MC
  MC_Name:="MC20.exe" ; Enter Short MC Name
}
If ProcessExist("Media Center 21.exe")
{
  MC_Path:="C:\Program Files (x86)\J River\Media Center 21\Media Center 21.exe" ; Enter Full path to MC
  MC_Name:="MC21.exe" ; Enter Short MC Name
}

-------------- NVIDIA 3D Vision --------------------------------------------------------------------------
P_N3D:="C:\Program Files (x86)\NVIDIA Corporation\3D Vision\nvstlink.exe" ; Enter Full path to nvstlink
-------------- Cyberlink PowerDVD Classic Mode Configuration ----------------------------------------------------------
If Var2=PDVDClassic ; Enter Abbreviation of the Program to run that will be used in the Second Variable from MC
{
  P_DIR:="C:\Program Files (x86)\Cyberlink\PowerDVD15\PDVDLP.exe" ; Enter the Full path to the Program
  P_WinName:="PowerDVD" ; Enter the Title of the Window when running
  P_Switch:="/LaunchProgram PowerDVD" ; Enter any Additionial Switches to include
  P_Prev = P ; Remaps the PgUp Button on a RC to a Keyboard Command
  P_Next = N ; Remaps the PgDn Button on a RC to a Keyboard Command
}
-------------- Cyberlink PowerDVD Cinema Mode Configuration ----------------------------------------------------------
If Var2=PDVDCinema ; Enter Abbreviation of the Program to run that will be used in the Second Variable from MC
{
  P_DIR:="C:\Program Files (x86)\Cyberlink\PowerDVD15\PDVDLP.exe" ; Enter the Full path to the Program
  P_WinName:="PowerDVD" ; Enter the Title of the Window when running
  P_Switch:="/LaunchProgram PowerDVDCinema" ; Enter any Additionial Switches to include
  P_Prev = P ; Remaps the PgUp Button on a RC to a Keyboard Command
  P_Next = N ; Remaps the PgDn Button on a RC to a Keyboard Command
}
-------------- Stereoscopic Player Configuration ---------------------------------------------------------
If Var2=SP ; Enter Abbreviation of the Program to run that will be used in the Second Variable from MC
{
  P_DIR:="C:\Program Files (x86)\Stereoscopic Player\StereoPlayer.exe" ; Enter the Full path to the Program
  P_WinName:="Stereoscopic Player" ; Enter the Title of the Window when running
  P_Switch:="-fss" ; Enter any Additionial Switches to include
  P_Prev = ^{PgUp} ; Remaps the PgUp Button on a RC to a Keyboard Command
  P_Next = ^{PgDn} ; Remaps the PgDn Button on a RC to a Keyboard Command
}
-------------- Arcsoft TMT Configuration -----------------------------------------------------------------
If Var2=TMT ; Enter Abbreviation of the Program to run that will be used in the Second Variable from MC
{
  P_DIR:="C:\Program Files (x86)\ArcSoft\TotalMedia Theatre 6\uMCEPlayer6.exe" ; Enter the Full path to the Program
  P_WinName:="TotalMedia" ; Enter the Title of the Window when running
  P_Switch:="" ; Enter any Additionial Switches to include
  P_Prev = {PgUp} ; Remaps the PgUp Button on a RC to a Keyboard Command
  P_Next = {PgDn} ; Remaps the PgDn Button on a RC to a Keyboard Command
}

; ********************************************************************************************************
; User Settings - Edit the values to match your player above
; ********************************************************************************************************
; --------------------------------------------------------------------------------------------------------
; Launch Player - No need to change
; --------------------------------------------------------------------------------------------------------
Send {Esc}
Run_Player:
  Progress, b w200, Launching %P_WinName%, Please Wait
  If Var3=N3D
  {
    run %P_N3D% /enable
    Progress, 50
    Sleep, 4000
  }
  Run %P_DIR% "%Var1%" %P_Switch%
  Progress, 75
  WinWait %P_WinName%
  Progress, Off
  WinActivate %P_WinName%
  WinMaximize, %P_WinName%
Return
; --------------------------------------------------------------------------------------------------------
; Media Key Handling
; --------------------------------------------------------------------------------------------------------

Media_Play_Pause::
  Send {Space}
return

0::
  IfWinExist, PowerDVD
    Send Z
  IfWinNotExist, %P_WinName%
    GoSub Run_Player
return

Media_Prev::
  Send %P_Prev%
return

Media_Next::
  Send %P_Next%
Return

; --------------------------------------------------------------------------------------------------------
; Stop Action
; --------------------------------------------------------------------------------------------------------

Media_Stop::  ; This is the STOP button (Media_Stop) - you can change to suit your requirements
  If Var3=N3D
    run %P_N3D% /disable
  ChangeDisplaySettings( cD, sW, sH, rR ) 

  WinClose, %P_WinName%
  WinActivate, JRiver
  Send {Down}{Down}{Enter}
  Send {Backspace}

  If P_WinName=PowerDVD
    for process in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process where Name like '%PowerDVD%'")
        Process, Close, % process.Name

  ExitApp

; --------------------------------------------------------------------------------------------------------
; The script that makes various System Calls - Don't Change
; --------------------------------------------------------------------------------------------------------
ChangeDisplaySettings( cD, sW, sH, rR ) 
{ 
  VarSetCapacity(dM,156,0), NumPut(156,2,&dM,36) 
  DllCall( "EnumDisplaySettings", UInt,0, UInt,-1, UInt,&dM ), NumPut(0x5c0000,dM,40) 
  NumPut(cD,dM,104),  NumPut(sW,dM,108),  NumPut(sH,dM,112),  NumPut(rR,dM,120) 
  Return DllCall( "ChangeDisplaySettings", UInt,&dM, UInt,0 ) 
}  

ProcessExist(Name)
{
	Process,Exist,%Name%
	return Errorlevel
}